import numpy as np
import matplotlib
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D

def produce_field(N):
    X = np.arange(N,dtype=np.float64)/np.float(N)
    Y = np.arange(N,dtype=np.float64)/np.float(N)
    Y, X = np.meshgrid(X, Y)
    R = np.sqrt((X-0.4)**2 + (Y-0.6)**2)

    sigma = 0.05
    return (X,Y,np.exp(-0.5*(R-0.15)**2/sigma**2))

def xderivative(N):
    X = np.arange(N,dtype=np.float64)/np.float(N)
    Y = np.arange(N,dtype=np.float64)/np.float(N)
    Y, X = np.meshgrid(X, Y)
    R = np.sqrt((X-0.4)**2 + (Y-0.6)**2)

    sigma = 0.05
    return - (R-0.15)*(X-0.4)/sigma**2/R * np.exp(-0.5*(R-0.15)**2/sigma**2)

def yderivative(N):
    X = np.arange(N,dtype=np.float64)/np.float(N)
    Y = np.arange(N,dtype=np.float64)/np.float(N)
    Y, X = np.meshgrid(X, Y)
    R = np.sqrt((X-0.4)**2 + (Y-0.6)**2)

    sigma = 0.05
    return - (R-0.15)*(Y-0.6)/sigma**2/R * np.exp(-0.5*(R-0.15)**2/sigma**2)
